/// \file Global.cs
/// \brief Global functions and definitons


namespace GTracks {

	/// \class Global
	/// \brief Global utility functions and definitions.
	public class Global {

		/// The user's HOME directory.
		public static string HomeDirectory {
			get {
				return System.IO.Path.Combine (System.Environment.GetEnvironmentVariable ("HOME"), "");	
			}
		}

		/// The base directory for our files. This is based on the
		/// HOME directory and the normal GNOME2 configuration
		/// directory.
		public static string BaseDirectory {
			get {
				return System.IO.Path.Combine (HomeDirectory,  System.IO.Path.Combine (".gnome2", "gtracks"));
			}
		}
	}
}
